#!/usr/bin/python
"""
FUNCTION: As some programs have problems with long fasta header
          simplify_fasta_headers.py produces a fasta file with
          simple number header and a tranlation table file.

USAGE: simplify_fasta_headers.py <INPUT_FASTA_FILE>

Copyright (c) 2008, Konrad Foerstner <konrad@foerstner.org>

Permission to use, copy, modify, and/or distribute this software for
any purpose with or without fee is hereby granted, provided that the
above copyright notice and this permission notice appear in all
copies.

THE SOFTWARE IS PROVIDED 'AS IS' AND THE AUTHOR DISCLAIMS ALL
WARRANTIES WITH REGARD TO THIS SOFTWARE INCLUDING ALL IMPLIED
WARRANTIES OF MERCHANTABILITY AND FITNESS. IN NO EVENT SHALL THE
AUTHOR BE LIABLE FOR ANY SPECIAL, DIRECT, INDIRECT, OR CONSEQUENTIAL
DAMAGES OR ANY DAMAGES WHATSOEVER RESULTING FROM LOSS OF USE, DATA OR
PROFITS, WHETHER IN AN ACTION OF CONTRACT, NEGLIGENCE OR OTHER
TORTIOUS ACTION, ARISING OUT OF OR IN CONNECTION WITH THE USE OR
PERFORMANCE OF THIS SOFTWARE.
         
"""
__author__ = "Konrad Foerstner <konrad@foerstner.org>"
__copyright__ = "2007 by Konrad Foerstner <konrad@foerstner.org>"
__license__ = "ISC license"

import sys
import fastaparser

def main():
    if not len(sys.argv) == 2:
        print __doc__
        sys.exit(2)
    parser = fastaparser.FastaParser()
    counter = 0
    output_fasta_file = open('%s.head_repl' % (sys.argv[1]), 'w')
    output_table_file = open('%s.repl_table' % (sys.argv[1]), 'w')
    for header, seq in parser.parse_fasta_file(sys.argv[1]):
        counter += 1
        output_fasta_file.write('>%s\n%s\n' % (
            counter, parser.shape_sequence(seq, 60)))
        output_table_file.write('%s\t%s\n' % (counter, header))
    output_fasta_file.close()
    output_table_file.close()
main()
